"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  DatePicker: () => DatePicker_default
});
module.exports = __toCommonJS(src_exports);

// src/components/DatePicker.tsx
var import_react3 = __toESM(require("react"));
var import_s_date = __toESM(require("@saanaa-ui/s-date"));

// src/components/Header.tsx
var import_react2 = __toESM(require("react"));

// src/icon/Arrow.tsx
var import_react = __toESM(require("react"));
var Arrow = () => {
  return /* @__PURE__ */ import_react.default.createElement(
    "svg",
    {
      xmlns: "http://www.w3.org/2000/svg",
      fill: "none",
      viewBox: "0 0 24 24",
      strokeWidth: 1.5,
      stroke: "currentColor",
      className: "w-5 h-5"
    },
    /* @__PURE__ */ import_react.default.createElement(
      "path",
      {
        strokeLinecap: "round",
        strokeLinejoin: "round",
        d: "m4.5 15.75 7.5-7.5 7.5 7.5"
      }
    )
  );
};

// src/components/Header.tsx
var Header = ({ onPrevMonth, onNextMonth }) => {
  return /* @__PURE__ */ import_react2.default.createElement("div", { className: "calendar__header s-absolute s-top-0 s-inset-x-0" }, /* @__PURE__ */ import_react2.default.createElement("button", { className: "calendar__header--btn -right", onClick: onPrevMonth }, /* @__PURE__ */ import_react2.default.createElement(Arrow, null)), /* @__PURE__ */ import_react2.default.createElement("button", { className: "calendar__header--btn -left", onClick: onNextMonth }, /* @__PURE__ */ import_react2.default.createElement(Arrow, null)));
};
var Header_default = Header;

// src/components/DatePicker.tsx
var locale = "fa";
var currentYear;
var currentMonth;
var year;
var month;
var DatePicker = ({
  onChange,
  title = "\u062A\u0627\u0631\u06CC\u062E \u0627\u0646\u062A\u062E\u0627\u0628\u06CC",
  numberOfMonth = 1,
  subTitles,
  isDisabledPast = true,
  SubmitBtnAction = () => {
  }
}) => {
  const [localeState, setLocaleState] = (0, import_react3.useState)("fa");
  const [localeTitle, setLocaleTitle] = (0, import_react3.useState)("\u062A\u0642\u0648\u06CC\u0645 \u0645\u06CC\u0644\u0627\u062F\u06CC");
  const [selectedDate, setSelectedDate] = (0, import_react3.useState)();
  const todayGregorian = import_s_date.default.format("en", /* @__PURE__ */ new Date(), "/").YYYY_MM_dd;
  let months = [];
  const [monthsState, setMonthsState] = (0, import_react3.useState)([]);
  const toggleCalendarType = () => {
    if (locale === "en") {
      locale = "fa";
      setLocaleTitle("\u062A\u0642\u0648\u06CC\u0645 \u0645\u06CC\u0644\u0627\u062F\u06CC");
    } else {
      locale = "en";
      setLocaleTitle("\u062A\u0642\u0648\u06CC\u0645 \u0634\u0645\u0633\u06CC");
    }
    year = currentYear = import_s_date.default.format(locale, /* @__PURE__ */ new Date()).YYYY;
    month = currentMonth = import_s_date.default.format(locale, /* @__PURE__ */ new Date()).MM;
    getMonthDetails(year, month);
  };
  const next = () => {
    if (+month + 1 === 13) {
      year = +year + 1;
      month = 1;
    } else
      month = +month + 1;
    getMonthDetails(year, month);
  };
  const previous = () => {
    if (isDisabledPast && +month === +currentMonth && +year === +currentYear)
      return null;
    if (+month - 1 === 0) {
      year = +year - 1;
      month = 12;
    } else
      month = +month - 1;
    getMonthDetails(year, month);
    return;
  };
  const gotoToday = () => {
    year = currentYear;
    month = currentMonth;
    getMonthDetails(currentYear, currentMonth);
  };
  function getSubTitles(date) {
    if (subTitles) {
      const index = subTitles.findIndex((x) => x.date === date + "T00:00:00");
      if (index >= 0) {
        return subTitles[index].value;
      } else {
        return null;
      }
    } else {
      return null;
    }
  }
  const handleChange = (date) => {
    setSelectedDate(date);
    onChange(date.jalaliDate);
    title = date.jalaliDate;
  };
  const getMonthDetails = (year2, month2) => {
    let firstDayOfMonth = null;
    let numberOfDays = null;
    let days = [];
    months = [];
    for (let monthIndex = 0; monthIndex < numberOfMonth; monthIndex++) {
      if (+month2 + +monthIndex === 13) {
        month2 = 1;
        year2 = +year2 + 1;
      } else
        month2 = +month2 + +monthIndex;
      if (locale === "en") {
        firstDayOfMonth = import_s_date.default.format(
          locale,
          year2 + "/" + month2.toString().padStart(2, "0") + "/01"
        );
      } else {
        firstDayOfMonth = `${year2}/${month2.toString().padStart(2, "0")}/01`;
        firstDayOfMonth = import_s_date.default.convert("en", firstDayOfMonth);
      }
      numberOfDays = import_s_date.default.DaysInMonth(locale, year2, month2);
      let date = firstDayOfMonth.YYYY_MM_dd;
      for (let index = 0; index < numberOfDays; index++) {
        const masterDate = import_s_date.default.format(locale, date);
        const gregorianDate = import_s_date.default.format("en", date);
        const jalaliDate = import_s_date.default.convert("fa", gregorianDate.YYYY_MM_dd);
        days.push({
          value: gregorianDate.YYYY_MM_dd.replaceAll("/", ""),
          gregorianDate: gregorianDate.YYYY_MM_dd,
          jalaliDate: jalaliDate.YYYY_MM_dd,
          year: masterDate.YYYY,
          month: masterDate.MM,
          monthName: masterDate.M,
          day: masterDate.d,
          weekDay: masterDate.W,
          weekDayNumber: masterDate.WW,
          isPassed: import_s_date.default.datoToNumber(date) < import_s_date.default.datoToNumber(todayGregorian),
          subTitle: getSubTitles(import_s_date.default.format("en", date, "-").YYYY_MM_dd)
        });
        date = import_s_date.default.addDays("en", date, 1).YYYY_MM_dd;
      }
      months.push({
        year: import_s_date.default.format(locale, firstDayOfMonth.YYYY_MM_dd).YYYY,
        month: import_s_date.default.format(locale, firstDayOfMonth.YYYY_MM_dd).MM,
        monthName: import_s_date.default.format(locale, firstDayOfMonth.YYYY_MM_dd).M,
        days
      });
      days = [];
    }
    console.log("months : ", months);
    setMonthsState([...months]);
    setLocaleState(locale);
  };
  (0, import_react3.useEffect)(() => {
    year = currentYear = import_s_date.default.convert("fa", /* @__PURE__ */ new Date()).YYYY;
    month = currentMonth = import_s_date.default.convert("fa", /* @__PURE__ */ new Date()).MM;
    getMonthDetails(year, month);
  }, []);
  const createArray = (start, end) => {
    if (start && end) {
      return [...Array(end - start + 1).keys()].map((num) => num + start);
    } else
      return [];
  };
  return /* @__PURE__ */ import_react3.default.createElement(
    "div",
    {
      className: `calendar ${numberOfMonth > 1 ? "active" : ""} ${locale === "fa" ? "-rtl" : "-ltr"}`
    },
    /* @__PURE__ */ import_react3.default.createElement("div", { className: "calendar__navigation fixed-position" }, /* @__PURE__ */ import_react3.default.createElement(
      "button",
      {
        type: "button",
        onClick: gotoToday,
        className: "s-py-1 s-px-2 md:s-py-2 md:s-px-3 s-inline-flex s-items-center s-gap-x-2 s-text-sm s-font-medium s-rounded-md s-border s-border-gray-200 s-bg-white s-text-gray-800 hover:s-bg-gray-50 disabled:s-opacity-50 disabled:s-pointer-events-none dark:s-bg-slate-900 dark:s-border-gray-700 dark:s-text-white dark:hover:s-bg-gray-800 dark:focus:s-outline-none dark:focus:s-ring-1 dark:focus:s-ring-gray-600"
      },
      "\u0628\u0631\u0648 \u0628\u0647 \u0627\u0645\u0631\u0648\u0632"
    ), /* @__PURE__ */ import_react3.default.createElement(
      "button",
      {
        type: "button",
        onClick: toggleCalendarType,
        className: "s-py-1 s-px-2 md:s-py-2 md:s-px-3 s-inline-flex s-items-center s-gap-x-2 s-text-sm s-font-semibold s-rounded-md s-border s-border-transparent !s-bg-blue-600 s-text-white hover:s-bg-blue-700 disabled:s-opacity-50 disabled:s-pointer-events-none dark:focus:s-outline-none dark:focus:s-ring-1 dark:focus:s-ring-gray-600"
      },
      localeTitle
    )),
    /* @__PURE__ */ import_react3.default.createElement("div", { className: "s-relative s-w-full s-block" }, /* @__PURE__ */ import_react3.default.createElement(Header_default, { onNextMonth: next, onPrevMonth: previous }), /* @__PURE__ */ import_react3.default.createElement("div", { className: "s-p-3 s-grid md:s-flex s-gap-8" }, monthsState.map((monthItem, monthIndex) => /* @__PURE__ */ import_react3.default.createElement("div", { key: monthIndex, className: "s-flex-1 s-mt-[2px]" }, /* @__PURE__ */ import_react3.default.createElement("div", { className: "s-grid s-grid-cols-5 s-items-center s-gap-x-3 s-mx-1.5 s-pb-3" }, /* @__PURE__ */ import_react3.default.createElement("div", { className: "s-col-span-5 s-flex s-justify-center s-items-center s-gap-x-1" }, /* @__PURE__ */ import_react3.default.createElement("div", { className: "s-relative s-text-gray-800 dark:s-text-gray-200" }, monthItem.monthName && !isDisabledPast ? /* @__PURE__ */ import_react3.default.createElement(
      "select",
      {
        onChange: (e) => {
          currentMonth = e.target.value;
          getMonthDetails(currentYear, currentMonth);
        }
      },
      locale === "fa" ? /* @__PURE__ */ import_react3.default.createElement(import_react3.default.Fragment, null, /* @__PURE__ */ import_react3.default.createElement("option", { value: 1 }, " \u0641\u0631\u0648\u0631\u062F\u06CC\u0646 "), /* @__PURE__ */ import_react3.default.createElement("option", { value: 2 }, "\u0627\u0631\u062F\u06CC\u0628\u0647\u0634\u062A"), /* @__PURE__ */ import_react3.default.createElement("option", { value: 3 }, "\u062E\u0631\u062F\u0627\u062F"), /* @__PURE__ */ import_react3.default.createElement("option", { value: 4 }, "\u062A\u06CC\u0631"), /* @__PURE__ */ import_react3.default.createElement("option", { value: 5 }, "\u0645\u0631\u062F\u0627\u062F"), /* @__PURE__ */ import_react3.default.createElement("option", { value: 6 }, "\u0634\u0647\u0631\u06CC\u0648\u0631"), /* @__PURE__ */ import_react3.default.createElement("option", { value: 7, selected: true }, "\u0645\u0647\u0631"), /* @__PURE__ */ import_react3.default.createElement("option", { value: 8 }, "\u0622\u0628\u0627\u0646"), /* @__PURE__ */ import_react3.default.createElement("option", { value: 9 }, "\u0622\u0630\u0631"), /* @__PURE__ */ import_react3.default.createElement("option", { value: 10 }, "\u062F\u06CC"), /* @__PURE__ */ import_react3.default.createElement("option", { value: 11 }, "\u0628\u0647\u0645\u0646"), /* @__PURE__ */ import_react3.default.createElement("option", { value: 12 }, "\u0627\u0633\u0641\u0646\u062F")) : /* @__PURE__ */ import_react3.default.createElement(import_react3.default.Fragment, null, /* @__PURE__ */ import_react3.default.createElement("option", { value: 1 }, "January"), /* @__PURE__ */ import_react3.default.createElement("option", { value: 2 }, "February"), /* @__PURE__ */ import_react3.default.createElement("option", { value: 3 }, "March"), /* @__PURE__ */ import_react3.default.createElement("option", { value: 4 }, "April"), /* @__PURE__ */ import_react3.default.createElement("option", { value: 5 }, "May"), /* @__PURE__ */ import_react3.default.createElement("option", { value: 6 }, "June"), /* @__PURE__ */ import_react3.default.createElement("option", { value: 7, selected: true }, "July"), /* @__PURE__ */ import_react3.default.createElement("option", { value: 8 }, "August"), /* @__PURE__ */ import_react3.default.createElement("option", { value: 9 }, "September"), /* @__PURE__ */ import_react3.default.createElement("option", { value: 10 }, "October"), /* @__PURE__ */ import_react3.default.createElement("option", { value: 11 }, "November"), /* @__PURE__ */ import_react3.default.createElement("option", { value: 12 }, "December"))
    ) : monthItem.monthName), /* @__PURE__ */ import_react3.default.createElement("span", { className: "s-text-gray-800 s-mx-2 dark:s-text-gray-200" }, "/"), /* @__PURE__ */ import_react3.default.createElement("div", { className: "s-relative s-text-gray-800 dark:s-text-gray-200" }, monthItem.year && !isDisabledPast ? /* @__PURE__ */ import_react3.default.createElement(
      "select",
      {
        onChange: (e) => {
          currentYear = e.target.value;
          getMonthDetails(currentYear, currentMonth);
        }
      },
      createArray(+currentYear - 100, +currentYear).map(
        (item) => /* @__PURE__ */ import_react3.default.createElement(
          "option",
          {
            key: item,
            value: item,
            selected: item === +currentYear
          },
          item
        )
      )
    ) : monthItem.year))), localeState === "fa" ? /* @__PURE__ */ import_react3.default.createElement("div", { className: "days-of-week s-grid s-grid-cols-7 s-mb-1 s-mt-2" }, /* @__PURE__ */ import_react3.default.createElement("span", { className: "dow s-text-center s-h-6 s-leading-6 s-text-sm s-font-medium s-text-gray-500 dark:s-text-gray-400" }, "\u0634"), /* @__PURE__ */ import_react3.default.createElement("span", { className: "dow s-text-center s-h-6 s-leading-6 s-text-sm s-font-medium s-text-gray-500 dark:s-text-gray-400" }, "\u06CC"), /* @__PURE__ */ import_react3.default.createElement("span", { className: "dow s-text-center s-h-6 s-leading-6 s-text-sm s-font-medium s-text-gray-500 dark:s-text-gray-400" }, "\u062F"), /* @__PURE__ */ import_react3.default.createElement("span", { className: "dow s-text-center s-h-6 s-leading-6 s-text-sm s-font-medium s-text-gray-500 dark:s-text-gray-400" }, "\u0633"), /* @__PURE__ */ import_react3.default.createElement("span", { className: "dow s-text-center s-h-6 s-leading-6 s-text-sm s-font-medium s-text-gray-500 dark:s-text-gray-400" }, "\u0686"), /* @__PURE__ */ import_react3.default.createElement("span", { className: "dow s-text-center s-h-6 s-leading-6 s-text-sm s-font-medium s-text-gray-500 dark:s-text-gray-400" }, "\u067E"), /* @__PURE__ */ import_react3.default.createElement("span", { className: "dow s-text-center s-h-6 s-leading-6 s-text-sm s-font-medium s-text-gray-500 dark:s-text-gray-400" }, "\u062C")) : /* @__PURE__ */ import_react3.default.createElement("div", { className: "days-of-week s-grid s-grid-cols-7 s-mb-1 s-mt-2" }, /* @__PURE__ */ import_react3.default.createElement("span", { className: "dow s-text-center s-h-6 s-leading-6 s-text-sm s-font-medium s-text-gray-500 dark:s-text-gray-400" }, "Fr"), /* @__PURE__ */ import_react3.default.createElement("span", { className: "dow s-text-center s-h-6 s-leading-6 s-text-sm s-font-medium s-text-gray-500 dark:s-text-gray-400" }, "Th"), /* @__PURE__ */ import_react3.default.createElement("span", { className: "dow s-text-center s-h-6 s-leading-6 s-text-sm s-font-medium s-text-gray-500 dark:s-text-gray-400" }, "We"), /* @__PURE__ */ import_react3.default.createElement("span", { className: "dow s-text-center s-h-6 s-leading-6 s-text-sm s-font-medium s-text-gray-500 dark:s-text-gray-400" }, "Tu"), /* @__PURE__ */ import_react3.default.createElement("span", { className: "dow s-text-center s-h-6 s-leading-6 s-text-sm s-font-medium s-text-gray-500 dark:s-text-gray-400" }, "Mo"), /* @__PURE__ */ import_react3.default.createElement("span", { className: "dow s-text-center s-h-6 s-leading-6 s-text-sm s-font-medium s-text-gray-500 dark:s-text-gray-400" }, "Su"), /* @__PURE__ */ import_react3.default.createElement("span", { className: "dow s-text-center s-h-6 s-leading-6 s-text-sm s-font-medium s-text-gray-500 dark:s-text-gray-400" }, "Sa")), /* @__PURE__ */ import_react3.default.createElement(
      "div",
      {
        className: "calendar__grid s-w-65 s-grid s-grid-cols-7 s-gap-1",
        dir: localeState === "en" ? "ltr" : ""
      },
      Array.from({
        length: parseInt(monthItem.days[0].weekDayNumber)
      }).map((_, dayIndex1) => /* @__PURE__ */ import_react3.default.createElement("span", { key: dayIndex1, className: "calendar__cell" })),
      monthItem.days.map((dayItem, dayIndex) => /* @__PURE__ */ import_react3.default.createElement(
        "span",
        {
          key: dayIndex,
          className: `calendar__cell s-cursor-pointer s-flex s-flex-col s-justify-center s-items-center hover:s-bg-gray-100 dark:hover:s-bg-gray-600 s-rounded-md s-text-center s-text-gray-600 dark:s-text-white s-font-semibold s-text-sm ${Number(dayItem.weekDayNumber) === 6 ? "is-holiday" : ""}  ${dayItem.isPassed && isDisabledPast ? "is-disabled is-passed" : ""} ${todayGregorian === dayItem.gregorianDate ? "is-today" : ""} ${dayItem.value === (selectedDate == null ? void 0 : selectedDate.value) ? "is-selected" : ""}`,
          "data-date": dayItem.value,
          onClick: () => {
            if (!dayItem.isPassed && isDisabledPast) {
              onChange(dayItem.jalaliDate);
              handleChange(dayItem);
            }
          }
        },
        dayItem.isPassed && isDisabledPast ? /* @__PURE__ */ import_react3.default.createElement("span", { className: "is-pass" }) : null,
        parseInt(dayItem.day),
        dayItem.subTitle && /* @__PURE__ */ import_react3.default.createElement("small", { className: "s-block s-text-gray-400 -s-mt-[2px] s-text-xs" }, dayItem.subTitle)
      ))
    )))), /* @__PURE__ */ import_react3.default.createElement("div", { className: "calendar__footer fixed-position" }, /* @__PURE__ */ import_react3.default.createElement(
      "button",
      {
        type: "button",
        onClick: SubmitBtnAction,
        className: "s-py-1 s-px-2 md:s-py-2 md:s-px-3 s-inline-flex s-items-center s-gap-x-2 s-text-sm s-font-semibold s-rounded-md s-border s-border-transparent !s-bg-blue-600 s-text-white hover:s-bg-blue-700 disabled:s-opacity-50 disabled:s-pointer-events-none dark:focus:s-outline-none dark:focus:s-ring-1 dark:focus:s-ring-gray-600"
      },
      "\u062A\u0627\u06CC\u06CC\u062F"
    ), /* @__PURE__ */ import_react3.default.createElement("div", { className: "md:s-ms-3 !s-text-sm md:!s-text-base s-text-gray-800 dark:s-text-gray-200 [direction:rtl]" }, /* @__PURE__ */ import_react3.default.createElement("span", { className: "s-font-medium" }, title, ": "), /* @__PURE__ */ import_react3.default.createElement("strong", { className: "s-font-bold" }, locale === "fa" ? (selectedDate == null ? void 0 : selectedDate.gregorianDate) ? import_s_date.default.convert("fa", selectedDate == null ? void 0 : selectedDate.gregorianDate).W_YYYY_M_dd : "\u0627\u0646\u062A\u062E\u0627\u0628 \u06A9\u0646\u06CC\u062F" : (selectedDate == null ? void 0 : selectedDate.gregorianDate) ? import_s_date.default.format("en", selectedDate == null ? void 0 : selectedDate.gregorianDate).W_YYYY_M_dd : "\u0627\u0646\u062A\u062E\u0627\u0628 \u06A9\u0646\u06CC\u062F"))))
  );
};
var DatePicker_default = DatePicker;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  DatePicker
});
//# sourceMappingURL=index.js.map